diff -pruN 3.7.7-1/debian/changelog 3.7.9-1/debian/changelog
--- 3.7.7-1/debian/changelog	2020-01-06 16:12:10.000000000 +0000
+++ 3.7.9-1/debian/changelog	2020-03-29 17:23:06.000000000 +0000
@@ -1,3 +1,11 @@
+ccache (3.7.9-1) unstable; urgency=medium
+
+  * Add elfutils to Build-Depends
+  * New upstream release 3.7.9
+  * Bump Standards-Version to 4.4.1 with no changes
+
+ -- Joel Rosdahl <joel@debian.org>  Sun, 29 Mar 2020 19:23:06 +0200
+
 ccache (3.7.7-1) unstable; urgency=medium
 
   * New upstream release 3.7.7
diff -pruN 3.7.7-1/debian/control 3.7.9-1/debian/control
--- 3.7.7-1/debian/control	2020-01-06 16:12:10.000000000 +0000
+++ 3.7.9-1/debian/control	2020-03-29 17:23:06.000000000 +0000
@@ -2,8 +2,8 @@ Source: ccache
 Section: devel
 Priority: optional
 Maintainer: Joel Rosdahl <joel@debian.org>
-Build-Depends: debhelper-compat (= 12), zlib1g-dev, dpkg-dev (>= 1.16.1~)
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 12), zlib1g-dev, dpkg-dev (>= 1.16.1~), elfutils
+Standards-Version: 4.4.1
 Homepage: https://ccache.dev
 
 Package: ccache
diff -pruN 3.7.7-1/dev.mk.in 3.7.9-1/dev.mk.in
--- 3.7.7-1/dev.mk.in	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/dev.mk.in	2020-03-29 14:11:45.000000000 +0000
@@ -190,9 +190,10 @@ doc/ccache.1: doc/MANUAL.xml
 
 .PHONY: update-authors
 update-authors:
-	git log --pretty=format:"%H %aN" \
-	  | grep -Ev 'd7c5056beda5483fcd5c098165fffd9be86fe98d' \
-	  | sed -r 's/[^ ]+/*/' \
+	git log --pretty=format:"%H %aN%n%(trailers:only)" \
+	  | grep -Ev 'd7c5056beda5483fcd5c098165fffd9be86fe98d|http|Conflicts:' \
+	  | grep '^[^ ]' \
+	  | sed -r -e 's/[^ ]+/*/' -e 's/<.*//' -e 's/ *$$//' \
 	  | sort -u \
 	  | perl -00 -p -i -e 's/^\*.*/<STDIN> . "\n"/es' doc/AUTHORS.adoc
 
diff -pruN 3.7.7-1/doc/AUTHORS.adoc 3.7.9-1/doc/AUTHORS.adoc
--- 3.7.7-1/doc/AUTHORS.adoc	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/AUTHORS.adoc	2020-03-29 14:11:45.000000000 +0000
@@ -6,13 +6,14 @@ maintained by Joel Rosdahl.
 
 ccache is a collective work with contributions from many people, including:
 
+* Alexander Korsunsky
 * Alexey Tourbin
 * Alfred Landrum
 * Anders F Björklund
 * Andrea Bittau
 * Andreas Huber
 * André Klitzing
-* Andrew P Boie
+* Andrew Boie
 * Andrew Stubbs
 * Andrew Tridgell
 * Bernhard Bauer
@@ -93,6 +94,7 @@ ccache is a collective work with contrib
 * RW
 * Ryan Brown
 * Sam Gross
+* Steffen Dettmer
 * Thomas Otto
 * Thomas Röfer
 * Timofei Kushnir
diff -pruN 3.7.7-1/doc/AUTHORS.html 3.7.9-1/doc/AUTHORS.html
--- 3.7.7-1/doc/AUTHORS.html	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/AUTHORS.html	2020-03-29 14:11:45.000000000 +0000
@@ -735,7 +735,7 @@ asciidoc.install(2);
 <body class="article">
 <div id="header">
 <h1>ccache authors</h1>
-<span id="revnumber">version 3.7.7</span>
+<span id="revnumber">version 3.7.9</span>
 <div id="toc">
   <div id="toctitle">Table of Contents</div>
   <noscript><p><b>JavaScript must be enabled in your browser to display the table of contents.</b></p></noscript>
@@ -750,6 +750,11 @@ maintained by Joel Rosdahl.</p></div>
 <div class="ulist"><ul>
 <li>
 <p>
+Alexander Korsunsky
+</p>
+</li>
+<li>
+<p>
 Alexey Tourbin
 </p>
 </li>
@@ -780,7 +785,7 @@ André Klitzing
 </li>
 <li>
 <p>
-Andrew P Boie
+Andrew Boie
 </p>
 </li>
 <li>
@@ -1185,6 +1190,11 @@ Sam Gross
 </li>
 <li>
 <p>
+Steffen Dettmer
+</p>
+</li>
+<li>
+<p>
 Thomas Otto
 </p>
 </li>
@@ -1261,9 +1271,9 @@ Yvan Janssens
 <div id="footnotes"><hr /></div>
 <div id="footer">
 <div id="footer-text">
-Version 3.7.7<br />
+Version 3.7.9<br />
 Last updated
- 2020-01-05 21:09:39 CET
+ 2020-03-29 16:11:12 CEST
 </div>
 </div>
 </body>
diff -pruN 3.7.7-1/doc/ccache.1 3.7.9-1/doc/ccache.1
--- 3.7.7-1/doc/ccache.1	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/ccache.1	2020-03-29 14:11:45.000000000 +0000
@@ -2,12 +2,12 @@
 .\"     Title: ccache
 .\"    Author: [see the "Author" section]
 .\" Generator: DocBook XSL Stylesheets v1.79.1 <http://docbook.sf.net/>
-.\"      Date: 01/05/2020
+.\"      Date: 03/29/2020
 .\"    Manual: ccache Manual
-.\"    Source: ccache 3.7.7
+.\"    Source: ccache 3.7.9
 .\"  Language: English
 .\"
-.TH "CCACHE" "1" "01/05/2020" "ccache 3\&.7\&.7" "ccache Manual"
+.TH "CCACHE" "1" "03/29/2020" "ccache 3\&.7\&.9" "ccache Manual"
 .\" -----------------------------------------------------------------
 .\" * Define some portability stuff
 .\" -----------------------------------------------------------------
@@ -722,7 +722,7 @@ is enabled\&. This can be useful when ba
 .PP
 \fBinclude_file_ctime\fR
 .RS 4
-By default, ccache also will not cache a file if it includes a header whose ctime is too new\&. This option disables that check\&.
+By default, ccache will not cache a file if it includes a header whose ctime is too new\&. This option disables that check\&.
 .RE
 .PP
 \fBinclude_file_mtime\fR
@@ -2075,7 +2075,7 @@ This was the first compilation with a ne
 A modification time of one of the include files is too new (created the same second as the compilation is being done)\&. This check is made to avoid a race condition\&. To fix this, create the include file earlier in the build process, if possible, or set
 \fBsloppiness\fR
 to
-\fBinclude_file_mtime\fR
+\fBinclude_file_ctime, include_file_mtime\fR
 if you are willing to take the risk\&. (The race condition consists of these events: the preprocessor is run; an include file is modified by someone; the new include file is hashed by ccache; the real compiler is run on the preprocessor\(cqs output, which contains data from the old header file; the wrong object file is stored in the cache\&.)
 .RE
 .sp
diff -pruN 3.7.7-1/doc/MANUAL.adoc 3.7.9-1/doc/MANUAL.adoc
--- 3.7.7-1/doc/MANUAL.adoc	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/MANUAL.adoc	2020-03-29 14:11:45.000000000 +0000
@@ -570,7 +570,7 @@ still has to do _some_ preprocessing (li
     Ignore ctimes when *file_stat_matches* is enabled. This can be useful when
     backdating files' mtimes in a controlled way.
 *include_file_ctime*::
-    By default, ccache also will not cache a file if it includes a header whose
+    By default, ccache will not cache a file if it includes a header whose
     ctime is too new. This option disables that check.
 *include_file_mtime*::
     By default, ccache will not cache a file if it includes a header whose
@@ -1189,13 +1189,13 @@ problems and what may be done to increas
    setting.
 ** A modification time of one of the include files is too new (created the same
    second as the compilation is being done). This check is made to avoid a race
-   condition. To fix this, create the include file earlier in the build
-   process, if possible, or set *sloppiness* to *include_file_mtime* if you are
-   willing to take the risk. (The race condition consists of these events: the
-   preprocessor is run; an include file is modified by someone; the new include
-   file is hashed by ccache; the real compiler is run on the preprocessor's
-   output, which contains data from the old header file; the wrong object file
-   is stored in the cache.)
+   condition. To fix this, create the include file earlier in the build process,
+   if possible, or set *sloppiness* to *include_file_ctime, include_file_mtime*
+   if you are willing to take the risk. (The race condition consists of these
+   events: the preprocessor is run; an include file is modified by someone; the
+   new include file is hashed by ccache; the real compiler is run on the
+   preprocessor's output, which contains data from the old header file; the
+   wrong object file is stored in the cache.)
 ** The `__TIME__` preprocessor macro is (potentially) being used. ccache turns
    off direct mode if `__TIME__` is present in the source code. This is done as
    a safety measure since the string indicates that a `__TIME__` macro _may_
diff -pruN 3.7.7-1/doc/MANUAL.html 3.7.9-1/doc/MANUAL.html
--- 3.7.7-1/doc/MANUAL.html	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/MANUAL.html	2020-03-29 14:11:45.000000000 +0000
@@ -735,7 +735,7 @@ asciidoc.install(2);
 <body class="article">
 <div id="header">
 <h1>CCACHE(1)</h1>
-<span id="revnumber">version 3.7.7</span>
+<span id="revnumber">version 3.7.9</span>
 <div id="toc">
   <div id="toctitle">Table of Contents</div>
   <noscript><p><b>JavaScript must be enabled in your browser to display the table of contents.</b></p></noscript>
@@ -1603,7 +1603,7 @@ still has to do <em>some</em> preprocess
 </dt>
 <dd>
 <p>
-    By default, ccache also will not cache a file if it includes a header whose
+    By default, ccache will not cache a file if it includes a header whose
     ctime is too new. This option disables that check.
 </p>
 </dd>
@@ -2581,13 +2581,13 @@ This was the first compilation with a ne
 <p>
 A modification time of one of the include files is too new (created the same
    second as the compilation is being done). This check is made to avoid a race
-   condition. To fix this, create the include file earlier in the build
-   process, if possible, or set <strong>sloppiness</strong> to <strong>include_file_mtime</strong> if you are
-   willing to take the risk. (The race condition consists of these events: the
-   preprocessor is run; an include file is modified by someone; the new include
-   file is hashed by ccache; the real compiler is run on the preprocessor&#8217;s
-   output, which contains data from the old header file; the wrong object file
-   is stored in the cache.)
+   condition. To fix this, create the include file earlier in the build process,
+   if possible, or set <strong>sloppiness</strong> to <strong>include_file_ctime, include_file_mtime</strong>
+   if you are willing to take the risk. (The race condition consists of these
+   events: the preprocessor is run; an include file is modified by someone; the
+   new include file is hashed by ccache; the real compiler is run on the
+   preprocessor&#8217;s output, which contains data from the old header file; the
+   wrong object file is stored in the cache.)
 </p>
 </li>
 <li>
@@ -2713,9 +2713,9 @@ maintained by Joel Rosdahl. See AUTHORS.
 <div id="footnotes"><hr /></div>
 <div id="footer">
 <div id="footer-text">
-Version 3.7.7<br />
+Version 3.7.9<br />
 Last updated
- 2020-01-05 21:09:39 CET
+ 2020-03-29 16:11:12 CEST
 </div>
 </div>
 </body>
diff -pruN 3.7.7-1/doc/NEWS.adoc 3.7.9-1/doc/NEWS.adoc
--- 3.7.7-1/doc/NEWS.adoc	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/NEWS.adoc	2020-03-29 14:11:45.000000000 +0000
@@ -1,6 +1,71 @@
 ccache news
 ===========
 
+ccache 3.7.9
+------------
+Release date: 2020-03-29
+
+Bug fixes
+~~~~~~~~~
+
+- Fixed replacing of /dev/null when building as root with hard link mode
+  enabled and using `-o /dev/null`.
+
+- Removed incorrect assertion resulting in “ccache: error: Internal error in
+  format” when using `-fdebug-prefix-map=X=` with X equal to `$PWD`.
+
+
+Other
+~~~~~
+
+- Improved CUDA/NVCC support: Recognize `-dc` and `-x cu` options.
+
+- Improved name of temporary file used in NFS-safe unlink.
+
+
+ccache 3.7.8
+------------
+Release date: 2020-03-16
+
+Bug fixes
+~~~~~~~~~
+
+- Use `$PWD` instead of the real CWD (current working directory) when checking
+  for CWD in preprocessed output. This fixes a problem when `$PWD` includes a
+  symlink part and the user has set `hash_dir = false`.
+
+- Rewrote the Windows version of the lockfile routines. This should mitigate
+  several problems with the old implementation.
+
+- If `localtime_r` fails the epoch time is now logged instead of garbage.
+
+
+Other
+~~~~~
+
+- Improved error message when a boolean environment variable has an invalid
+  value.
+
+- Improved the regression fix in ccache 3.7.5 related to not passing
+  compilation-only options to the preprocessor.
+
+- ccache’s PCH test suite now skips running the tests if it detects broken PCH
+  compiler support.
+
+- Fixed unit test failure on Windows.
+
+- Fixed “stringop-truncation” build warning on Windows.
+
+- Improved “x_rename” implementation on Windows.
+
+- Improved removal of temporary file when rewriting absolute paths to relative
+  in the dependency file.
+
+- Clarified “include_file_ctime sloppiness” in the Performance section in the
+  manual.
+
+
+
 ccache 3.7.7
 ------------
 Release date: 2020-01-05
diff -pruN 3.7.7-1/doc/NEWS.html 3.7.9-1/doc/NEWS.html
--- 3.7.7-1/doc/NEWS.html	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/doc/NEWS.html	2020-03-29 14:11:45.000000000 +0000
@@ -735,7 +735,7 @@ asciidoc.install(2);
 <body class="article">
 <div id="header">
 <h1>ccache news</h1>
-<span id="revnumber">version 3.7.7</span>
+<span id="revnumber">version 3.7.9</span>
 <div id="toc">
   <div id="toctitle">Table of Contents</div>
   <noscript><p><b>JavaScript must be enabled in your browser to display the table of contents.</b></p></noscript>
@@ -743,11 +743,128 @@ asciidoc.install(2);
 </div>
 <div id="content">
 <div class="sect1">
+<h2 id="_ccache_3_7_9">ccache 3.7.9</h2>
+<div class="sectionbody">
+<div class="paragraph"><p>Release date: 2020-03-29</p></div>
+<div class="sect2">
+<h3 id="_bug_fixes">Bug fixes</h3>
+<div class="ulist"><ul>
+<li>
+<p>
+Fixed replacing of /dev/null when building as root with hard link mode
+  enabled and using <code>-o /dev/null</code>.
+</p>
+</li>
+<li>
+<p>
+Removed incorrect assertion resulting in “ccache: error: Internal error in
+  format” when using <code>-fdebug-prefix-map=X=</code> with X equal to <code>$PWD</code>.
+</p>
+</li>
+</ul></div>
+</div>
+<div class="sect2">
+<h3 id="_other">Other</h3>
+<div class="ulist"><ul>
+<li>
+<p>
+Improved CUDA/NVCC support: Recognize <code>-dc</code> and <code>-x cu</code> options.
+</p>
+</li>
+<li>
+<p>
+Improved name of temporary file used in NFS-safe unlink.
+</p>
+</li>
+</ul></div>
+</div>
+</div>
+</div>
+<div class="sect1">
+<h2 id="_ccache_3_7_8">ccache 3.7.8</h2>
+<div class="sectionbody">
+<div class="paragraph"><p>Release date: 2020-03-16</p></div>
+<div class="sect2">
+<h3 id="_bug_fixes_2">Bug fixes</h3>
+<div class="ulist"><ul>
+<li>
+<p>
+Use <code>$PWD</code> instead of the real CWD (current working directory) when checking
+  for CWD in preprocessed output. This fixes a problem when <code>$PWD</code> includes a
+  symlink part and the user has set <code>hash_dir = false</code>.
+</p>
+</li>
+<li>
+<p>
+Rewrote the Windows version of the lockfile routines. This should mitigate
+  several problems with the old implementation.
+</p>
+</li>
+<li>
+<p>
+If <code>localtime_r</code> fails the epoch time is now logged instead of garbage.
+</p>
+</li>
+</ul></div>
+</div>
+<div class="sect2">
+<h3 id="_other_2">Other</h3>
+<div class="ulist"><ul>
+<li>
+<p>
+Improved error message when a boolean environment variable has an invalid
+  value.
+</p>
+</li>
+<li>
+<p>
+Improved the regression fix in ccache 3.7.5 related to not passing
+  compilation-only options to the preprocessor.
+</p>
+</li>
+<li>
+<p>
+ccache’s PCH test suite now skips running the tests if it detects broken PCH
+  compiler support.
+</p>
+</li>
+<li>
+<p>
+Fixed unit test failure on Windows.
+</p>
+</li>
+<li>
+<p>
+Fixed “stringop-truncation” build warning on Windows.
+</p>
+</li>
+<li>
+<p>
+Improved “x_rename” implementation on Windows.
+</p>
+</li>
+<li>
+<p>
+Improved removal of temporary file when rewriting absolute paths to relative
+  in the dependency file.
+</p>
+</li>
+<li>
+<p>
+Clarified “include_file_ctime sloppiness” in the Performance section in the
+  manual.
+</p>
+</li>
+</ul></div>
+</div>
+</div>
+</div>
+<div class="sect1">
 <h2 id="_ccache_3_7_7">ccache 3.7.7</h2>
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2020-01-05</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes">Bug fixes</h3>
+<h3 id="_bug_fixes_3">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -795,7 +912,7 @@ The “cache miss” statistics counter
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2019-11-17</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_2">Bug fixes</h3>
+<h3 id="_bug_fixes_4">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -842,7 +959,7 @@ Added support for <code>-MF=arg</code> (
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_3">Bug fixes</h3>
+<h3 id="_bug_fixes_5">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -912,7 +1029,7 @@ Added support for converting paths like
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2019-08-17</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_4">Bug fixes</h3>
+<h3 id="_bug_fixes_6">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -937,7 +1054,7 @@ Fixed a regression in 3.7.2 when using t
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2019-07-19</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_5">Bug fixes</h3>
+<h3 id="_bug_fixes_7">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1394,7 +1511,7 @@ Made “./configure --without-bundled-zl
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2018-09-02</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_6">Bug fixes</h3>
+<h3 id="_bug_fixes_8">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1431,7 +1548,7 @@ Upgraded bundled zlib to version 1.2.11.
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2018-03-25</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_7">Bug fixes</h3>
+<h3 id="_bug_fixes_9">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1475,7 +1592,7 @@ Made it possible to perform out-of-sourc
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2018-02-11</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_8">Bug fixes</h3>
+<h3 id="_bug_fixes_10">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1561,7 +1678,7 @@ Documented caveats related to colored wa
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_9">Bug fixes</h3>
+<h3 id="_bug_fixes_11">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1599,7 +1716,7 @@ Improved instructions on how to get cach
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_10">Bug fixes</h3>
+<h3 id="_bug_fixes_12">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1625,7 +1742,7 @@ Documented how automatic cache cleanup w
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_11">Bug fixes</h3>
+<h3 id="_bug_fixes_13">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1708,7 +1825,7 @@ Documented the different cache statistic
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_12">Bug fixes</h3>
+<h3 id="_bug_fixes_14">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1738,7 +1855,7 @@ Fixed undefined behavior warnings in cca
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-10-26</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_13">Bug fixes</h3>
+<h3 id="_bug_fixes_15">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1755,7 +1872,7 @@ ccache now detects usage of <code>.incbi
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-09-28</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_14">Bug fixes</h3>
+<h3 id="_bug_fixes_16">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1780,7 +1897,7 @@ Fixed a regression in ccache 3.3.1: ccac
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-09-07</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_15">Bug fixes</h3>
+<h3 id="_bug_fixes_17">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1962,7 +2079,7 @@ Increased buffer size used when reading
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_16">Bug fixes</h3>
+<h3 id="_bug_fixes_18">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -1988,7 +2105,7 @@ Fixed build and test for MinGW32 and Win
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-09-28</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_17">Bug fixes</h3>
+<h3 id="_bug_fixes_19">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2006,7 +2123,7 @@ Fixed a regression in ccache 3.2.8: ccac
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-09-07</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_18">Bug fixes</h3>
+<h3 id="_bug_fixes_20">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2030,7 +2147,7 @@ ccache now understands the undocumented
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-07-20</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_19">Bug fixes</h3>
+<h3 id="_bug_fixes_21">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2053,7 +2170,7 @@ ccache now knows how to work around a gl
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-07-12</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_20">Bug fixes</h3>
+<h3 id="_bug_fixes_22">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2103,7 +2220,7 @@ Made it harder to misinterpret documenta
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_21">Bug fixes</h3>
+<h3 id="_bug_fixes_23">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2163,7 +2280,7 @@ The man page is now built when running 
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2015-10-08</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_22">Bug fixes</h3>
+<h3 id="_bug_fixes_24">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2218,7 +2335,7 @@ Added support for compiler option <code>
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_23">Bug fixes</h3>
+<h3 id="_bug_fixes_25">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2272,7 +2389,7 @@ Add support for caching code coverage re
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_24">Bug fixes</h3>
+<h3 id="_bug_fixes_26">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2342,7 +2459,7 @@ Fixed build error when compiling ccache
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2014-12-10</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_25">Bug fixes</h3>
+<h3 id="_bug_fixes_27">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2574,7 +2691,7 @@ Various other improvements of the test s
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_26">Bug fixes</h3>
+<h3 id="_bug_fixes_28">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2605,7 +2722,7 @@ Fixed test suite failures when <code>CC<
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2016-07-12</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_27">Bug fixes</h3>
+<h3 id="_bug_fixes_29">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2623,7 +2740,7 @@ Fixed a bug where (due to ccache rewriti
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2015-03-07</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_28">Bug fixes</h3>
+<h3 id="_bug_fixes_30">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2705,7 +2822,7 @@ Stale files in the internal temporary di
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_29">Bug fixes</h3>
+<h3 id="_bug_fixes_31">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2745,7 +2862,7 @@ Fixed problem with logging of current wo
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2013-01-06</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_30">Bug fixes</h3>
+<h3 id="_bug_fixes_32">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2779,7 +2896,7 @@ Disappearing temporary stdout/stderr fil
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other">Other</h3>
+<h3 id="_other_3">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2816,7 +2933,7 @@ Clang plugins are now hashed to catch pl
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_31">Bug fixes</h3>
+<h3 id="_bug_fixes_33">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2843,7 +2960,7 @@ Paths are now correctly canonicalized wh
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other_2">Other</h3>
+<h3 id="_other_4">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2864,7 +2981,7 @@ Fixed <code>static_assert</code> macro d
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2012-01-08</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_32">Bug fixes</h3>
+<h3 id="_bug_fixes_34">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2916,7 +3033,7 @@ Reverted the GCC bug compatibility intro
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other_3">Other</h3>
+<h3 id="_other_5">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -2947,7 +3064,7 @@ Rewrite argument to <code>--sysroot</cod
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_33">Bug fixes</h3>
+<h3 id="_bug_fixes_35">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3000,7 +3117,7 @@ Improved order of statistics counters in
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_34">Bug fixes</h3>
+<h3 id="_bug_fixes_36">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3033,7 +3150,7 @@ Systems that lack (and don’t need to b
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2011-01-09</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_35">Bug fixes</h3>
+<h3 id="_bug_fixes_37">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3066,7 +3183,7 @@ The file handle in now correctly closed
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2010-11-28</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_36">Bug fixes</h3>
+<h3 id="_bug_fixes_38">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3077,7 +3194,7 @@ The -MFarg, -MTarg and -MQarg compiler o
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other_4">Other</h3>
+<h3 id="_other_6">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3093,7 +3210,7 @@ Portability fixes for HP-UX 11.00 and ot
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2010-11-21</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_37">Bug fixes</h3>
+<h3 id="_bug_fixes_39">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3114,7 +3231,7 @@ Fixed issue when parsing precompiler out
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other_5">Other</h3>
+<h3 id="_other_7">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3141,7 +3258,7 @@ The test suite now also works on systems
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2010-11-07</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_38">Bug fixes</h3>
+<h3 id="_bug_fixes_40">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3179,7 +3296,7 @@ ccache development version (set by dev.m
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other_6">Other</h3>
+<h3 id="_other_8">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3263,7 +3380,7 @@ Added <code>-install_name</code> as an o
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_39">Bug fixes</h3>
+<h3 id="_bug_fixes_41">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3288,7 +3405,7 @@ EINTR is now handled correctly.
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_other_7">Other</h3>
+<h3 id="_other_9">Other</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3349,7 +3466,7 @@ New <code>HACKING.txt</code> file with s
 <div class="sectionbody">
 <div class="paragraph"><p>Release date: 2010-07-15</p></div>
 <div class="sect2">
-<h3 id="_bug_fixes_40">Bug fixes</h3>
+<h3 id="_bug_fixes_42">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3538,7 +3655,7 @@ The following options are no longer hash
 </ul></div>
 </div>
 <div class="sect2">
-<h3 id="_bug_fixes_41">Bug fixes</h3>
+<h3 id="_bug_fixes_43">Bug fixes</h3>
 <div class="ulist"><ul>
 <li>
 <p>
@@ -3683,9 +3800,9 @@ Statistics counters are now correctly up
 <div id="footnotes"><hr /></div>
 <div id="footer">
 <div id="footer-text">
-Version 3.7.7<br />
+Version 3.7.9<br />
 Last updated
- 2020-01-05 21:09:39 CET
+ 2020-03-29 16:11:12 CEST
 </div>
 </div>
 </body>
diff -pruN 3.7.7-1/LICENSE.html 3.7.9-1/LICENSE.html
--- 3.7.7-1/LICENSE.html	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/LICENSE.html	2020-03-29 14:11:45.000000000 +0000
@@ -735,7 +735,7 @@ asciidoc.install(2);
 <body class="article">
 <div id="header">
 <h1>ccache copyright and license</h1>
-<span id="revnumber">version 3.7.7</span>
+<span id="revnumber">version 3.7.9</span>
 <div id="toc">
   <div id="toctitle">Table of Contents</div>
   <noscript><p><b>JavaScript must be enabled in your browser to display the table of contents.</b></p></noscript>
@@ -1235,9 +1235,9 @@ following license:</p></div>
 <div id="footnotes"><hr /></div>
 <div id="footer">
 <div id="footer-text">
-Version 3.7.7<br />
+Version 3.7.9<br />
 Last updated
- 2020-01-05 21:09:39 CET
+ 2020-03-29 16:11:12 CEST
 </div>
 </div>
 </body>
diff -pruN 3.7.7-1/src/ccache.c 3.7.9-1/src/ccache.c
--- 3.7.7-1/src/ccache.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/src/ccache.c	2020-03-29 14:11:45.000000000 +0000
@@ -914,7 +914,7 @@ process_preprocessed_file(struct hash *h
 
 	init_included_files_table();
 
-	char *cwd = gnu_getcwd();
+	char *cwd = get_cwd();
 
 	// Bytes between p and q are pending to be hashed.
 	char *p = data;
@@ -1156,7 +1156,7 @@ out:
 	}
 	if (!result) {
 		cc_log("Removing temporary dependency file: %s", tmp_file);
-		x_unlink(tmp_file);
+		tmp_unlink(tmp_file);
 	}
 	free(tmp_file);
 }
@@ -1299,6 +1299,11 @@ move_file_to_cache_same_fs(const char *s
 static void
 do_copy_or_link_file_from_cache(const char *source, const char *dest, bool copy)
 {
+	if (str_eq(dest, "/dev/null")) {
+		cc_log("Skipping copy from %s to %s", source, dest);
+		return;
+	}
+
 	int ret;
 	bool do_link = !copy && conf->hard_link && !file_is_compressed(source);
 	if (do_link) {
@@ -1432,7 +1437,8 @@ to_cache(struct args *args, struct hash
 	args_add(args, "-o");
 	args_add(args, output_obj);
 
-	if (conf->hard_link) {
+	if (conf->hard_link && !str_eq(output_obj, "/dev/null")) {
+		// This is a workaround for https://bugs.llvm.org/show_bug.cgi?id=39782.
 		x_unlink(output_obj);
 	}
 
@@ -1910,7 +1916,7 @@ calculate_common_hash(struct args *args,
 
 	// Possibly hash the current working directory.
 	if (generating_debuginfo && conf->hash_dir) {
-		char *cwd = gnu_getcwd();
+		char *cwd = get_cwd();
 		for (size_t i = 0; i < debug_prefix_maps_len; i++) {
 			char *map = debug_prefix_maps[i];
 			char *sep = strchr(map, '=');
@@ -2009,7 +2015,8 @@ calculate_common_hash(struct args *args,
 // modes and calculate the object hash. Returns the object hash on success,
 // otherwise NULL. Caller frees.
 static struct file_hash *
-calculate_object_hash(struct args *args, struct hash *hash, int direct_mode)
+calculate_object_hash(struct args *args, struct args *preprocessor_args,
+                      struct hash *hash, int direct_mode)
 {
 	bool found_ccbin = false;
 
@@ -2166,7 +2173,7 @@ calculate_object_hash(struct args *args,
 		hash_delimiter(hash, "/dev/null dependency file");
 	}
 
-	if (!found_ccbin && str_eq(actual_language, "cuda")) {
+	if (!found_ccbin && str_eq(actual_language, "cu")) {
 		hash_nvcc_host_compiler(hash, NULL, NULL);
 	}
 
@@ -2273,23 +2280,24 @@ calculate_object_hash(struct args *args,
 			cc_log("Did not find object file hash in manifest");
 		}
 	} else {
+		assert(preprocessor_args);
 		if (arch_args_size == 0) {
-			object_hash = get_object_name_from_cpp(args, hash);
+			object_hash = get_object_name_from_cpp(preprocessor_args, hash);
 			cc_log("Got object file hash from preprocessor");
 		} else {
-			args_add(args, "-arch");
+			args_add(preprocessor_args, "-arch");
 			for (size_t i = 0; i < arch_args_size; ++i) {
-				args_add(args, arch_args[i]);
-				object_hash = get_object_name_from_cpp(args, hash);
+				args_add(preprocessor_args, arch_args[i]);
+				object_hash = get_object_name_from_cpp(preprocessor_args, hash);
 				cc_log("Got object file hash from preprocessor with -arch %s",
 				       arch_args[i]);
 				if (i != arch_args_size - 1) {
 					free(object_hash);
 					object_hash = NULL;
 				}
-				args_pop(args, 1);
+				args_pop(preprocessor_args, 1);
 			}
-			args_pop(args, 1);
+			args_pop(preprocessor_args, 1);
 		}
 		if (generating_dependencies) {
 			// Nothing is actually created with -MF /dev/null
@@ -2535,6 +2543,7 @@ cc_process_args(struct args *args,
                 struct args **compiler_args)
 {
 	bool found_c_opt = false;
+	bool found_dc_opt = false;
 	bool found_S_opt = false;
 	bool found_pch = false;
 	bool found_fpch_preprocess = false;
@@ -2746,6 +2755,13 @@ cc_process_args(struct args *args,
 			continue;
 		}
 
+		// when using nvcc with separable compilation, -dc implies -c
+		if ((str_eq(argv[i], "-dc") || str_eq(argv[i], "--device-c"))
+		    && guessed_compiler == GUESSED_NVCC) {
+			found_dc_opt = true;
+			continue;
+		}
+
 		// -S changes the default extension.
 		if (str_eq(argv[i], "-S")) {
 			args_add(common_args, argv[i]);
@@ -3262,7 +3278,7 @@ cc_process_args(struct args *args,
 			if (language_for_file(argv[i])) {
 				cc_log("Multiple input files: %s and %s", input_file, argv[i]);
 				stats_update(STATS_MULTIPLE);
-			} else if (!found_c_opt) {
+			} else if (!found_c_opt && !found_dc_opt) {
 				cc_log("Called for link with %s", argv[i]);
 				if (strstr(argv[i], "conftest.")) {
 					stats_update(STATS_CONFTEST);
@@ -3403,7 +3419,7 @@ cc_process_args(struct args *args,
 		goto out;
 	}
 
-	if (!found_c_opt && !found_S_opt) {
+	if (!found_c_opt && !found_dc_opt && !found_S_opt) {
 		if (output_is_precompiled_header) {
 			args_add(common_args, "-c");
 		} else {
@@ -3427,7 +3443,7 @@ cc_process_args(struct args *args,
 		goto out;
 	}
 
-	if (!conf->run_second_cpp && str_eq(actual_language, "cuda")) {
+	if (!conf->run_second_cpp && str_eq(actual_language, "cu")) {
 		cc_log("Using CUDA compiler; not compiling preprocessed code");
 		conf->run_second_cpp = true;
 	}
@@ -3607,6 +3623,10 @@ cc_process_args(struct args *args,
 		args_add(*compiler_args, "-c");
 	}
 
+	if (found_dc_opt) {
+		args_add(*compiler_args, "-dc");
+	}
+
 	for (size_t i = 0; i < arch_args_size; ++i) {
 		args_add(*compiler_args, "-arch");
 		args_add(*compiler_args, arch_args[i]);
@@ -4041,7 +4061,7 @@ ccache(int argc, char *argv[])
 	if (conf->direct_mode) {
 		cc_log("Trying direct lookup");
 		MTR_BEGIN("hash", "direct_hash");
-		object_hash = calculate_object_hash(args_to_hash, direct_hash, 1);
+		object_hash = calculate_object_hash(args_to_hash, NULL, direct_hash, 1);
 		MTR_END("hash", "direct_hash");
 		if (object_hash) {
 			update_cached_result_globals(object_hash);
@@ -4074,7 +4094,8 @@ ccache(int argc, char *argv[])
 			cpp_hash, output_obj, 'p', "PREPROCESSOR MODE", debug_text_file);
 
 		MTR_BEGIN("hash", "cpp_hash");
-		object_hash = calculate_object_hash(args_to_hash, cpp_hash, 0);
+		object_hash = calculate_object_hash(
+			args_to_hash, preprocessor_args, cpp_hash, 0);
 		MTR_END("hash", "cpp_hash");
 		if (!object_hash) {
 			fatal("internal error: object hash from cpp returned NULL");
diff -pruN 3.7.7-1/src/conf.c 3.7.9-1/src/conf.c
--- 3.7.7-1/src/conf.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/src/conf.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2011-2019 Joel Rosdahl
+// Copyright (C) 2011-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -39,15 +39,15 @@ find_env_to_conf(const char *name)
 
 static enum handle_conf_result
 handle_conf_setting(struct conf *conf, const char *key, const char *value,
-                    char **errmsg, bool from_env_variable, bool negate_boolean,
-                    const char *origin)
+                    char **errmsg, const char *env_var_name,
+                    bool negate_boolean, const char *origin)
 {
 	const struct conf_item *item = find_conf(key);
 	if (!item) {
 		return HANDLE_CONF_UNKNOWN;
 	}
 
-	if (from_env_variable && item->parser == confitem_parse_bool) {
+	if (env_var_name && item->parser == confitem_parse_bool) {
 		// Special rule for boolean settings from the environment: "0", "false",
 		// "disable" and "no" (case insensitive) are invalid, and all other values
 		// mean true.
@@ -57,7 +57,13 @@ handle_conf_setting(struct conf *conf, c
 		// enabled.
 		if (str_eq(value, "0") || strcasecmp(value, "false") == 0
 		    || strcasecmp(value, "disable") == 0 || strcasecmp(value, "no") == 0) {
-			fatal("invalid boolean environment variable value \"%s\"", value);
+			fatal(
+				"invalid boolean environment variable value \"%s\" for CCACHE_%s%s"
+				" (did you mean to set \"CCACHE_%s%s=true\"?)",
+				value,
+				negate_boolean ? "NO" : "",
+				env_var_name, negate_boolean ? "" : "NO",
+				env_var_name);
 		}
 
 		bool *boolvalue = (bool *)((char *)conf + item->offset);
@@ -218,7 +224,7 @@ conf_read(struct conf *conf, const char
 		bool ok = parse_line(buf, &key, &value, &errmsg2);
 		if (ok && key) { // key == NULL if comment or blank line.
 			hcr =
-				handle_conf_setting(conf, key, value, &errmsg2, false, false, path);
+				handle_conf_setting(conf, key, value, &errmsg2, NULL, false, path);
 			ok = hcr != HANDLE_CONF_FAIL; // unknown is OK
 		}
 		free(key);
@@ -274,8 +280,8 @@ conf_update_from_environment(struct conf
 
 		char *errmsg2 = NULL;
 		enum handle_conf_result hcr = handle_conf_setting(
-			conf, env_to_conf_item->conf_name, q, &errmsg2, true, negate,
-			"environment");
+			conf, env_to_conf_item->conf_name, q, &errmsg2,
+			env_to_conf_item->env_name, negate, "environment");
 		if (hcr != HANDLE_CONF_OK) {
 			*errmsg = format("%s: %s", key, errmsg2);
 			free(errmsg2);
diff -pruN 3.7.7-1/src/language.c 3.7.9-1/src/language.c
--- 3.7.7-1/src/language.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/src/language.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2010-2018 Joel Rosdahl
+// Copyright (C) 2010-2019 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -62,8 +62,7 @@ static const struct {
 	{".HXX", "c++-header"},
 	{".tcc", "c++-header"},
 	{".TCC", "c++-header"},
-	{".cu",  "cuda"},
-	{".ic",  "cuda-output"},
+	{".cu",  "cu"},
 	{NULL,  NULL}
 };
 
@@ -78,6 +77,7 @@ static const struct {
 	{"c++",                      "c++-cpp-output"},
 	{"c++-cpp-output",           "c++-cpp-output"},
 	{"c++-header",               "c++-cpp-output"},
+	{"cu",                       "cpp-output"},
 	{"objective-c",              "objective-c-cpp-output"},
 	{"objective-c-header",       "objective-c-cpp-output"},
 	{"objc-cpp-output",          "objective-c-cpp-output"},
@@ -86,7 +86,6 @@ static const struct {
 	{"objc++-cpp-output",        "objective-c++-cpp-output"},
 	{"objective-c++-header",     "objective-c++-cpp-output"},
 	{"objective-c++-cpp-output", "objective-c++-cpp-output"},
-	{"cuda",                     "cuda-output"},
 	{"assembler-with-cpp",       "assembler"},
 	{"assembler",                "assembler"},
 	{NULL,  NULL}
diff -pruN 3.7.7-1/src/lockfile.c 3.7.9-1/src/lockfile.c
--- 3.7.7-1/src/lockfile.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/src/lockfile.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2010-2018 Joel Rosdahl
+// Copyright (C) 2010-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -16,6 +16,8 @@
 
 #include "ccache.h"
 
+#ifndef _WIN32
+
 // This function acquires a lockfile for the given path. Returns true if the
 // lock was acquired, otherwise false. If the lock has been considered stale
 // for the number of microseconds specified by staleness_limit, the function
@@ -34,65 +36,13 @@ lockfile_acquire(const char *path, unsig
 	const char *hostname = get_hostname();
 	bool acquired = false;
 	unsigned to_sleep = 1000; // Microseconds.
+	unsigned max_to_sleep = 10000; // Microseconds.
 	unsigned slept = 0; // Microseconds.
 
 	while (true) {
 		free(my_content);
 		my_content = format("%s:%d:%d", hostname, (int)getpid(), (int)time(NULL));
 
-#ifdef _WIN32
-		int fd = open(lockfile, O_WRONLY|O_CREAT|O_EXCL|O_BINARY, 0666);
-		if (fd == -1) {
-			int saved_errno = errno;
-			cc_log("lockfile_acquire: open WRONLY %s: %s", lockfile, strerror(errno));
-			if (saved_errno == ENOENT) {
-				// Directory doesn't exist?
-				if (create_parent_dirs(lockfile) == 0) {
-					// OK. Retry.
-					continue;
-				}
-			}
-			if (saved_errno != EEXIST) {
-				// Directory doesn't exist or isn't writable?
-				goto out;
-			}
-			// Someone else has the lock.
-			fd = open(lockfile, O_RDONLY|O_BINARY);
-			if (fd == -1) {
-				if (errno == ENOENT) {
-					// The file was removed after the open() call above, so retry
-					// acquiring it.
-					continue;
-				} else {
-					cc_log("lockfile_acquire: open RDONLY %s: %s",
-					       lockfile, strerror(errno));
-					goto out;
-				}
-			}
-			free(content);
-			const size_t bufsize = 1024;
-			content = x_malloc(bufsize);
-			int len = read(fd, content, bufsize - 1);
-			if (len == -1) {
-				cc_log("lockfile_acquire: read %s: %s", lockfile, strerror(errno));
-				close(fd);
-				goto out;
-			}
-			close(fd);
-			content[len] = '\0';
-		} else {
-			// We got the lock.
-			if (write(fd, my_content, strlen(my_content)) == -1) {
-				cc_log("lockfile_acquire: write %s: %s", lockfile, strerror(errno));
-				close(fd);
-				x_unlink(lockfile);
-				goto out;
-			}
-			close(fd);
-			acquired = true;
-			goto out;
-		}
-#else
 		if (symlink(my_content, lockfile) == 0) {
 			// We got the lock.
 			acquired = true;
@@ -129,7 +79,6 @@ lockfile_acquire(const char *path, unsig
 				goto out;
 			}
 		}
-#endif
 
 		if (str_eq(content, my_content)) {
 			// Lost NFS reply?
@@ -164,7 +113,7 @@ lockfile_acquire(const char *path, unsig
 		       lockfile, to_sleep);
 		usleep(to_sleep);
 		slept += to_sleep;
-		to_sleep *= 2;
+		to_sleep = MIN(max_to_sleep, 2 * to_sleep);
 	}
 
 out:
@@ -191,23 +140,114 @@ lockfile_release(const char *path)
 	free(lockfile);
 }
 
+#else
+
+HANDLE lockfile_handle = NULL;
+
+// This function acquires a lockfile for the given path. Returns true if the
+// lock was acquired, otherwise false. If the lock has been acquired within the
+// limit (in microseconds) the function will give up and return false. The time
+// limit should be reasonably larger than the longest time the lock can be
+// expected to be held.
+bool
+lockfile_acquire(const char *path, unsigned time_limit)
+{
+	char *lockfile = format("%s.lock", path);
+	unsigned to_sleep = 1000; // Microseconds.
+	unsigned max_to_sleep = 10000; // Microseconds.
+	unsigned slept = 0; // Microseconds.
+	bool acquired = false;
+
+	while (true) {
+		DWORD flags = FILE_ATTRIBUTE_NORMAL | FILE_FLAG_DELETE_ON_CLOSE;
+		lockfile_handle = CreateFile(
+			lockfile,
+			GENERIC_WRITE, // desired access
+			0,             // shared mode (0 = not shared)
+			NULL,          // security attributes
+			CREATE_ALWAYS, // creation disposition,
+			flags,         // flags and attributes
+			NULL           // template file
+		);
+		if (lockfile_handle != INVALID_HANDLE_VALUE) {
+			acquired = true;
+			break;
+		}
+
+		DWORD error = GetLastError();
+		cc_log("lockfile_acquire: CreateFile %s: error code %lu", lockfile, error);
+		if (error == ERROR_PATH_NOT_FOUND) {
+			// Directory doesn't exist?
+			if (create_parent_dirs(lockfile) == 0) {
+				// OK. Retry.
+				continue;
+			}
+		}
+
+		// ERROR_SHARING_VIOLATION: lock already held.
+		// ERROR_ACCESS_DENIED: maybe pending delete.
+		if (error != ERROR_SHARING_VIOLATION && error != ERROR_ACCESS_DENIED) {
+			// Fatal error, give up.
+			break;
+		}
+
+		if (slept > time_limit) {
+			cc_log("lockfile_acquire: gave up acquiring %s", lockfile);
+			break;
+		}
+
+		cc_log("lockfile_acquire: failed to acquire %s; sleeping %u microseconds",
+		       lockfile, to_sleep);
+		usleep(to_sleep);
+		slept += to_sleep;
+		to_sleep = MIN(max_to_sleep, 2 * to_sleep);
+	}
+
+	if (acquired) {
+		cc_log("Acquired lock %s", lockfile);
+	} else {
+		cc_log("Failed to acquire lock %s", lockfile);
+	}
+	free(lockfile);
+	return acquired;
+}
+
+// Release the lockfile for the given path. Assumes that we are the legitimate
+// owner.
+void
+lockfile_release(const char *path)
+{
+	assert(lockfile_handle != INVALID_HANDLE_VALUE);
+	cc_log("Releasing lock %s.lock", path);
+	CloseHandle(lockfile_handle);
+	lockfile_handle = NULL;
+}
+
+#endif
+
 #ifdef TEST_LOCKFILE
+
 int
 main(int argc, char **argv)
 {
-	extern char *cache_logfile;
-	cache_logfile = "/dev/stdout";
-	if (argc == 4) {
+	extern struct conf *conf;
+	conf = conf_create();
+	if (argc == 3) {
 		unsigned staleness_limit = atoi(argv[1]);
-		if (str_eq(argv[2], "acquire")) {
-			return lockfile_acquire(argv[3], staleness_limit) == 0;
-		} else if (str_eq(argv[2], "release")) {
-			lockfile_release(argv[3]);
-			return 0;
+		printf("Acquiring\n");
+		bool acquired = lockfile_acquire(argv[2], staleness_limit);
+		if (acquired) {
+			printf("Sleeping 2 seconds\n");
+			sleep(2);
+			lockfile_release(argv[2]);
+			printf("Released\n");
+		} else {
+			printf("Failed to acquire\n");
 		}
+	} else {
+		fprintf(stderr,
+		        "Usage: testlockfile <staleness_limit> <path>\n");
 	}
-	fprintf(stderr,
-	        "Usage: testlockfile <staleness_limit> <acquire|release> <path>\n");
 	return 1;
 }
 #endif
diff -pruN 3.7.7-1/src/util.c 3.7.9-1/src/util.c
--- 3.7.7-1/src/util.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/src/util.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,5 +1,5 @@
 // Copyright (C) 2002 Andrew Tridgell
-// Copyright (C) 2009-2019 Joel Rosdahl
+// Copyright (C) 2009-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -97,12 +97,11 @@ log_prefix(bool log_updated_time)
 		struct tm tm;
 		struct timeval tv;
 		gettimeofday(&tv, NULL);
-#ifdef __MINGW64_VERSION_MAJOR
-		localtime_r((time_t *)&tv.tv_sec, &tm);
-#else
-		localtime_r(&tv.tv_sec, &tm);
-#endif
-		strftime(timestamp, sizeof(timestamp), "%Y-%m-%dT%H:%M:%S", &tm);
+		if (localtime_r((time_t *)&tv.tv_sec, &tm) != NULL) {
+			strftime(timestamp, sizeof(timestamp), "%Y-%m-%dT%H:%M:%S", &tm);
+		} else {
+			snprintf(timestamp, sizeof(timestamp), "%lu", tv.tv_sec);
+		}
 		snprintf(prefix, sizeof(prefix),
 		         "[%s.%06d %-5d] ", timestamp, (int)tv.tv_usec, (int)getpid());
 	}
@@ -704,9 +703,6 @@ format(const char *format, ...)
 	}
 	va_end(ap);
 
-	if (!*ptr) {
-		fatal("Internal error in format");
-	}
 	return ptr;
 }
 
@@ -1125,7 +1121,7 @@ static BOOL GetFileNameFromHandle(HANDLE
 								           TEXT("%s%s"),
 								           drive,
 								           filename+name_len);
-								_tcsncpy(filename, temp_file, _tcslen(temp_file));
+								strcpy(filename, temp_file);
 							}
 						}
 					}
@@ -1519,9 +1515,8 @@ x_rename(const char *oldpath, const char
 	return rename(oldpath, newpath);
 #else
 	// Windows' rename() refuses to overwrite an existing file.
-	unlink(newpath); // Not x_unlink, as x_unlink calls x_rename.
 	// If the function succeeds, the return value is nonzero.
-	if (MoveFileA(oldpath, newpath) == 0) {
+	if (MoveFileExA(oldpath, newpath, MOVEFILE_REPLACE_EXISTING) == 0) {
 		LPVOID lp_msg_buf;
 		DWORD dw = GetLastError();
 		FormatMessage(
@@ -1575,7 +1570,7 @@ do_x_unlink(const char *path, bool log_f
 	// If path is on an NFS share, unlink isn't atomic, so we rename to a temp
 	// file. We don't care if the temp file is trashed, so it's always safe to
 	// unlink it first.
-	char *tmp_name = format("%s.rm.%s", path, tmp_string());
+	char *tmp_name = format("%s.ccache.rm.tmp", path);
 
 	int result = 0;
 	if (x_rename(path, tmp_name) == -1) {
diff -pruN 3.7.7-1/src/version.c 3.7.9-1/src/version.c
--- 3.7.7-1/src/version.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/src/version.c	2020-03-29 14:11:45.000000000 +0000
@@ -1 +1 @@
-extern const char CCACHE_VERSION[]; const char CCACHE_VERSION[] = "3.7.7";
+extern const char CCACHE_VERSION[]; const char CCACHE_VERSION[] = "3.7.9";
diff -pruN 3.7.7-1/test/run 3.7.9-1/test/run
--- 3.7.7-1/test/run	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/test/run	2020-03-29 14:11:45.000000000 +0000
@@ -3,7 +3,7 @@
 # A simple test suite for ccache.
 #
 # Copyright (C) 2002-2007 Andrew Tridgell
-# Copyright (C) 2009-2019 Joel Rosdahl
+# Copyright (C) 2009-2020 Joel Rosdahl
 #
 # This program is free software; you can redistribute it and/or modify it under
 # the terms of the GNU General Public License as published by the Free Software
@@ -262,8 +262,12 @@ EOF
 
     cd /
     remove_cache
-    rm -rf $ABS_TESTDIR/run
-    mkdir $ABS_TESTDIR/run
+    rm -rf $ABS_TESTDIR/run $ABS_TESTDIR/run.real
+
+    # Verify that tests behave well when apparent CWD != actual CWD.
+    mkdir $ABS_TESTDIR/run.real
+    ln -s run.real $ABS_TESTDIR/run
+
     cd $ABS_TESTDIR/run
     if type SUITE_${suite_name}_SETUP >/dev/null 2>&1; then
         SUITE_${suite_name}_SETUP
diff -pruN 3.7.7-1/test/suites/base.bash 3.7.9-1/test/suites/base.bash
--- 3.7.7-1/test/suites/base.bash	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/test/suites/base.bash	2020-03-29 14:11:45.000000000 +0000
@@ -967,22 +967,40 @@ EOF
     # -------------------------------------------------------------------------
     TEST "Handling of compiler-only arguments"
 
-    $CCACHE_COMPILE -c test1.c
+    cat >compiler.sh <<EOF
+#!/bin/sh
+printf "[%s]" "\$*" >>compiler.args
+[ \$1 = -E ] && echo test || echo test >test1.o
+EOF
+    chmod +x compiler.sh
+    backdate compiler.sh
+
+    $CCACHE ./compiler.sh -c test1.c
     expect_stat 'cache hit (preprocessed)' 0
     expect_stat 'cache miss' 1
     expect_stat 'files in cache' 1
+    if [ -z "$CCACHE_NOCPP2" ]; then
+        expect_file_content compiler.args "[-E test1.c][-c -o test1.o test1.c]"
+    fi
+    rm compiler.args
 
-    $CCACHE_COMPILE -c test1.c
+    $CCACHE ./compiler.sh -c test1.c
     expect_stat 'cache hit (preprocessed)' 1
     expect_stat 'cache miss' 1
     expect_stat 'files in cache' 1
+    expect_file_content compiler.args "[-E test1.c]"
+    rm compiler.args
 
     # Even though -Werror is not passed to the preprocessor, it should be part
     # of the hash, so we expect a cache miss:
-    $CCACHE_COMPILE -c -Werror test1.c
+    $CCACHE ./compiler.sh -c -Werror -rdynamic test1.c
     expect_stat 'cache hit (preprocessed)' 1
     expect_stat 'cache miss' 2
     expect_stat 'files in cache' 2
+    if [ -z "$CCACHE_NOCPP2" ]; then
+        expect_file_content compiler.args "[-E test1.c][-Werror -rdynamic -c -o test1.o test1.c]"
+    fi
+    rm compiler.args
 
     # -------------------------------------------------------------------------
     TEST "Dependency file content"
diff -pruN 3.7.7-1/test/suites/nvcc.bash 3.7.9-1/test/suites/nvcc.bash
--- 3.7.7-1/test/suites/nvcc.bash	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/test/suites/nvcc.bash	2020-03-29 14:11:45.000000000 +0000
@@ -53,7 +53,7 @@ nvcc_tests() {
     # instead of comparing the binary object files, we compare the dumps of
     # "cuobjdump -all -elf -symbols -ptx -sass test1.o".
     nvcc_opts_cpp="-Wno-deprecated-gpu-targets -c --x c++"
-    nvcc_opts_cuda="-Wno-deprecated-gpu-targets -c"
+    nvcc_opts_cuda="-Wno-deprecated-gpu-targets -c -x cu"
     nvcc_opts_gpu1="--generate-code arch=compute_50,code=compute_50"
     nvcc_opts_gpu2="--generate-code arch=compute_52,code=sm_52"
     ccache_nvcc_cpp="$CCACHE $REAL_NVCC $nvcc_opts_cpp"
@@ -129,6 +129,26 @@ nvcc_tests() {
     expect_equal_files reference_test3.dump test1.dump
 
     # -------------------------------------------------------------------------
+    TEST "Option -dc"
+
+    $REAL_NVCC $nvcc_opts_cuda -dc -o reference_test4.o test_cuda.cu
+    $cuobjdump reference_test4.o > reference_test4.dump
+
+    $ccache_nvcc_cuda -dc -o test_cuda.o test_cuda.cu
+    expect_stat 'cache hit (preprocessed)' 0
+    expect_stat 'cache miss' 1
+    expect_stat 'files in cache' 1
+    $cuobjdump test_cuda.o > test4.dump
+    expect_equal_files test4.dump reference_test4.dump
+
+    $ccache_nvcc_cuda -dc -o test_cuda.o test_cuda.cu
+    expect_stat 'cache hit (preprocessed)' 1
+    expect_stat 'cache miss' 1
+    expect_stat 'files in cache' 1
+    $cuobjdump test_cuda.o > test4.dump
+    expect_equal_files test4.dump reference_test4.dump
+
+    # -------------------------------------------------------------------------
     TEST "Different defines"
 
     $REAL_NVCC $nvcc_opts_cpp            -o reference_test1.o test_cpp.cu
diff -pruN 3.7.7-1/test/suites/pch.bash 3.7.9-1/test/suites/pch.bash
--- 3.7.7-1/test/suites/pch.bash	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/test/suites/pch.bash	2020-03-29 14:11:45.000000000 +0000
@@ -1,8 +1,15 @@
 SUITE_pch_PROBE() {
-    touch pch.h
+    touch pch.h empty.c
+    mkdir dir
+
     if ! $REAL_COMPILER $SYSROOT -fpch-preprocess pch.h 2>/dev/null \
             || [ ! -f pch.h.gch ]; then
-        echo "compiler ($($COMPILER --version | head -1)) doesn't support precompiled headers"
+        echo "compiler ($($COMPILER --version | head -n 1)) doesn't support precompiled headers"
+    fi
+
+    $REAL_COMPILER $SYSROOT -c pch.h -o dir/pch.h.gch 2>/dev/null
+    if ! $REAL_COMPILER $SYSROOT -c -include dir/pch.h empty.c 2>/dev/null; then
+        echo "compiler ($($COMPILER --version | head -n 1)) seems to have broken support for precompiled headers"
     fi
 }
 
diff -pruN 3.7.7-1/unittest/test_args.c 3.7.9-1/unittest/test_args.c
--- 3.7.7-1/unittest/test_args.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/unittest/test_args.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2010-2018 Joel Rosdahl
+// Copyright (C) 2010-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -74,11 +74,7 @@ TEST(args_init_from_gcc_atfile)
 	CHECK_STR_EQ("fourth", args->argv[3]);
 	CHECK_STR_EQ("fif th", args->argv[4]);
 	CHECK_STR_EQ("si'x\" th", args->argv[5]);
-#ifndef _WIN32
 	CHECK_STR_EQ("seve\nth", args->argv[6]);
-#else
-	CHECK_STR_EQ("seve\r\nth", args->argv[6]);
-#endif
 	CHECK(!args->argv[7]);
 	args_free(args);
 }
diff -pruN 3.7.7-1/unittest/test_conf.c 3.7.9-1/unittest/test_conf.c
--- 3.7.7-1/unittest/test_conf.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/unittest/test_conf.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2011-2019 Joel Rosdahl
+// Copyright (C) 2011-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
diff -pruN 3.7.7-1/unittest/test_lockfile.c 3.7.9-1/unittest/test_lockfile.c
--- 3.7.7-1/unittest/test_lockfile.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/unittest/test_lockfile.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2010-2018 Joel Rosdahl
+// Copyright (C) 2010-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -22,43 +22,31 @@
 
 TEST_SUITE(lockfile)
 
-TEST(acquire_should_create_symlink)
+TEST(acquire_and_release)
 {
-	lockfile_acquire("test", 1000);
+	CHECK(lockfile_acquire("test", 1000));
 
 #ifdef _WIN32
 	CHECK(path_exists("test.lock"));
 #else
 	CHECK(is_symlink("test.lock"));
 #endif
-}
 
-TEST(release_should_delete_file)
-{
-	create_file("test.lock", "");
 	lockfile_release("test");
-
 	CHECK(!path_exists("test.lock"));
 }
 
+#ifndef _WIN32
+
 TEST(lock_breaking)
 {
 	char *p;
 
-#ifdef _WIN32
-	create_file("test.lock", "foo");
-	create_file("test.lock.lock", "foo");
-#else
 	CHECK_INT_EQ(0, symlink("foo", "test.lock"));
 	CHECK_INT_EQ(0, symlink("foo", "test.lock.lock"));
-#endif
 	CHECK(lockfile_acquire("test", 1000));
 
-#ifdef _WIN32
-	p = read_text_file("test.lock", 0);
-#else
 	p = x_readlink("test.lock");
-#endif
 	CHECK(p);
 	CHECK(!str_eq(p, "foo"));
 	CHECK(!path_exists("test.lock.lock"));
@@ -66,12 +54,12 @@ TEST(lock_breaking)
 	free(p);
 }
 
-#ifndef _WIN32
 TEST(failed_lock_breaking)
 {
 	create_file("test.lock", "");
 	CHECK(!lockfile_acquire("test", 1000));
 }
-#endif
+
+#endif // !_WIN32
 
 TEST_SUITE_END
diff -pruN 3.7.7-1/unittest/util.c 3.7.9-1/unittest/util.c
--- 3.7.7-1/unittest/util.c	2020-01-05 20:10:12.000000000 +0000
+++ 3.7.9-1/unittest/util.c	2020-03-29 14:11:45.000000000 +0000
@@ -1,4 +1,4 @@
-// Copyright (C) 2010-2018 Joel Rosdahl
+// Copyright (C) 2010-2020 Joel Rosdahl
 //
 // This program is free software; you can redistribute it and/or modify it
 // under the terms of the GNU General Public License as published by the Free
@@ -31,7 +31,7 @@ path_exists(const char *path)
 void
 create_file(const char *path, const char *content)
 {
-	FILE *f = fopen(path, "w");
+	FILE *f = fopen(path, "wb");
 	if (!f || fputs(content, f) < 0) {
 		fprintf(stderr, "create_file: %s: %s\n", path, strerror(errno));
 	}
